/*****************************************************************************
 * $Id: gfx_os.cc,v 1.21 2006/07/23 02:04:39 devel Exp $
 * @file
 * @author	Jim E. Brooks  http://www.jimbrooks.org
 * @brief	Operating-system specific functions.
 * @remarks	File functions are at gfx_file.cc.
 *//*
 * LEGAL:	COPYRIGHT (C) 2004 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE (GPL).
 *****************************************************************************/

#define GFX_OS_CC 1
#include "gfx.hh"
namespace gfx {

/*****************************************************************************
 * Relinquish CPU for specified milli-seconds.
 *****************************************************************************/
void
Snooze( uint milsec )
{
#if defined(_WIN32)				// Win32
	Sleep( milsec );
#else							// GNU (default)
	usleep( milsec * 1000 );
#endif
}

/*****************************************************************************
 * (Win32) Create a console so that printf() will work.
 *****************************************************************************/
#ifdef _WIN32
void
Win32CreateConsole( void )
{
	int		hCrt;
	FILE*	hf;
	AllocConsole();
	hCrt = _open_osfhandle( (long) GetStdHandle(STD_OUTPUT_HANDLE), _O_TEXT );
	hf = _fdopen( hCrt, "w" );
	*stdout = *hf;
	setvbuf( stdout, NULL, _IONBF, 0 );
}
#endif /* _WIN32 */

} // namespace gfx
